#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
vector<int> dist;
vector<int> visited;

void dfs(int u) {
	visited[u] = true;
	for (int v : g[u]) {
		if (visited[v]) continue;
		dist[v] = dist[u] + 1;
		dfs(v);
	}
}


int main()
{
	int n, k, t; cin >> n >> k >> t;
	if (t == 1) {
		g.resize(n);
		dist.resize(n);
		visited.resize(n);
		vector<int> ans(n);
		for (int i = 0; i < n - 1; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		for (int i = 0; i < n; i++) {
			dist.assign(n, 0);
			visited.assign(n, false);
			dist[i] = 0;
			dfs(i);
			sort(dist.begin(), dist.end());
			int ind = n - 1;
			int nk = k;
			while (nk) {
				dist[ind] = min(dist[ind], 1);
				ind--;
				nk--;
			}
			sort(dist.begin(), dist.end());
			ans[i] = dist[n - 1];
		}
		for (int i : ans) cout << i << ' ';
		cout << '\n';
	}
	else {
		g.resize(n);
		dist.resize(n);
		visited.resize(n);
		vector<int> ans(n);
		for (int i = 0; i < n - 1; i++) {
			int u, v; cin >> u >> v; u--; v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		for (int i = 0; i < 1; i++) {
			dist.assign(n, 0);
			visited.assign(n, false);
			dist[i] = 0;
			dfs(i);
			sort(dist.begin(), dist.end());
			int ind = n - 1;
			int nk = k;
			while (nk) {
				dist[ind] = min(dist[ind], 1);
				ind--;
				nk--;
			}
			sort(dist.begin(), dist.end());
			ans[i] = dist[n - 1];
		}
		cout << ans[0];
		cout << '\n';
	}

}